io.vertx.reactivex.core.eventbus

## Class MessageProducer<T>

- java.lang.Object
- - io.vertx.reactivex.core.eventbus.MessageProducer<T>

- All Implemented Interfaces:
    StreamBase, WriteStream<T>

      public class MessageProducer<T>
      extends Object
      implements WriteStream<T>

  Represents a stream of message that can be written to.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<MessageProducer>` | `__TYPE_ARG`
    `io.vertx.lang.rx.TypeArg<T>` | `__typeArg_0`
    `static int` | `DEFAULT_WRITE_QUEUE_MAX_SIZE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MessageProducer(MessageProducer delegate)`
    `MessageProducer(MessageProducer delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `address()`
    `void` | `close()` Closes the producer, this method should be called when the message producer is not used anymore.
    `void` | `close(Handler<AsyncResult<Void>> handler)` Same as `close()` but with an `handler` called when the operation completes
    `MessageProducer<T>` | `deliveryOptions(DeliveryOptions options)` Update the delivery options of this producer.
    `MessageProducer<T>` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Closes the producer, calls `close()`
    `void` | `end(Handler<AsyncResult<Void>> handler)` Closes the producer, calls `close()`
    `void` | `end(T data)` Same as `end(T)` but writes some data to the stream before ending.
    `void` | `end(T data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `boolean` | `equals(Object o)`
    `MessageProducer<T>` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the write stream.
    `MessageProducer` | `getDelegate()`
    `int` | `hashCode()`
    `static <T> MessageProducer<T>` | `newInstance(MessageProducer arg)`
    `static <T> MessageProducer<T>` | `newInstance(MessageProducer arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T)`
    `Completable` | `rxClose()` Same as `close()` but with an `handler` called when the operation completes
    `Completable` | `rxEnd()` Closes the producer, calls `close()`
    `Completable` | `rxEnd(T data)` Same as but with an `handler` called when the operation completes
    `Completable` | `rxWrite(T data)`
    `MessageProducer<T>` | `send(T message)` Deprecated.
    `<R> MessageProducer<T>` | `send(T message, Handler<AsyncResult<Message<R>>> replyHandler)` Deprecated.
    `MessageProducer<T>` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `io.vertx.reactivex.WriteStreamObserver<T>` | `toObserver()`
    `String` | `toString()`
    `io.vertx.reactivex.WriteStreamSubscriber<T>` | `toSubscriber()`
    `MessageProducer<T>` | `write(T data)` Write some data to the stream.
    `MessageProducer<T>` | `write(T data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<MessageProducer> __TYPE_ARG

    - #### __typeArg_0

          public final io.vertx.lang.rx.TypeArg<T> __typeArg_0

    - #### DEFAULT_WRITE_QUEUE_MAX_SIZE

          public static final int DEFAULT_WRITE_QUEUE_MAX_SIZE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MessageProducer

          public MessageProducer(MessageProducer delegate)

    - #### MessageProducer

          public MessageProducer(MessageProducer delegate,
                                 io.vertx.lang.rx.TypeArg<T> typeArg_0)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public MessageProducer getDelegate()

      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<T>`

    - #### toObserver

          public io.vertx.reactivex.WriteStreamObserver<T> toObserver()

    - #### toSubscriber

          public io.vertx.reactivex.WriteStreamSubscriber<T> toSubscriber()

    - #### end

          public void end(T data)

      Same as `end(T)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write

    - #### end

          public void end(T data,
                          Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WriteStream<T>`
      Parameters:
        `data` -
        `handler` -

    - #### rxEnd

          public Completable rxEnd(T data)

      Same as but with an `handler` called when the operation completes
      Parameters:
        `data` -
      Returns:

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<T>`
      Returns:
        true if write queue is full

    - #### send

          @Deprecated
          public MessageProducer<T> send(T message)

      Deprecated.
      This method actually sends a message using the send semantic regardless this producer is a sender or a publisher.
      Parameters:
        `message` - the message to send
      Returns:
        reference to this for fluency

    - #### send

          @Deprecated
          public <R> MessageProducer<T> send(T message,
                                                         Handler<AsyncResult<Message<R>>> replyHandler)

      Deprecated.
      Like `send(T)` but specifying a `replyHandler` that will be called if the recipient subsequently replies to the message.
      Parameters:
        `message` - the message to send
        `replyHandler` - reply handler will be called when any reply from the recipient is received, may be `null`
      Returns:
        reference to this for fluency

    - #### exceptionHandler

          public MessageProducer<T> exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public MessageProducer<T> write(T data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public MessageProducer<T> write(T data,
                                          Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WriteStream`
      Same as but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<T>`
      Returns:

    - #### rxWrite

          public Completable rxWrite(T data)

    - #### setWriteQueueMaxSize

          public MessageProducer<T> setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, the number of `Message` for a `MessageProducer`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<T>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public MessageProducer<T> drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pump` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.
      Specified by:
        `drainHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### deliveryOptions

          public MessageProducer<T> deliveryOptions(DeliveryOptions options)

      Update the delivery options of this producer.
      Parameters:
        `options` - the new options
      Returns:
        this producer object

    - #### address

          public String address()

      Returns:
        The address to which the producer produces messages.

    - #### end

          public void end()

      Closes the producer, calls `close()`
      Specified by:
        `end` in interface `WriteStream<T>`

    - #### end

          public void end(Handler<AsyncResult<Void>> handler)

      Closes the producer, calls `close()`
      Specified by:
        `end` in interface `WriteStream<T>`
      Parameters:
        `handler` -

    - #### rxEnd

          public Completable rxEnd()

      Closes the producer, calls `close()`
      Returns:

    - #### close

          public void close()

      Closes the producer, this method should be called when the message producer is not used anymore.

    - #### close

          public void close(Handler<AsyncResult<Void>> handler)

      Same as `close()` but with an `handler` called when the operation completes
      Parameters:
        `handler` -

    - #### rxClose

          public Completable rxClose()

      Same as `close()` but with an `handler` called when the operation completes
      Returns:

    - #### newInstance

          public static <T> MessageProducer<T> newInstance(MessageProducer arg)

    - #### newInstance

          public static <T> MessageProducer<T> newInstance(MessageProducer arg,
                                                           io.vertx.lang.rx.TypeArg<T> __typeArg_T)

Copyright © 2019 Eclipse. All rights reserved.